{-# LANGUAGE QuasiQuotes #-}
module Promela.UpdateDecs where

import SCons
import Promela.Promela
import Promela.VarNames
import Promela.FromFile
import qualified Data.Text as T

updateDecs :: Algo -> T.Text
updateDecs a = T.pack $ pDefInline "update_decs" body
  where
    ss = a_rounds a
    decRounds = map fst
                $ filter (\(i, s) -> decName `elem` (map updTarget (instrs s)))
                $ zip [0..] ss
    body
      | null decRounds  = ""
      | otherwise       = pIf [(updCond, T.unpack [fromFile|src/Promela/fragments/update_decs.pml|])]
                          (Just "skip")
    updCond = foldr1 pOr (map (\i -> pEq rndVar (show i)) decRounds)

