module Promela.VarNames where

import SCons

encoderName :: String
encoderName = "encode_st"

decoderPrefix = "decode_"

decoderName :: FName -> String
decoderName fn = decoderPrefix ++ fn

updPrefix = "upd_"
updaterName :: FName -> String
updaterName fn = updPrefix ++ fn

ctrVarName :: String
ctrVarName = "st_ctr"

ldrStVarName :: String
ldrStVarName = "ldr_st"

cntBoundName :: String
cntBoundName = "ST_CNT"

tsVarName :: Int -> String
tsVarName n = "ts_of_" ++ show n

iVar :: Int -> String
iVar n = "_i" ++ show n

nVar :: Int -> String
nVar n = "_n" ++ show n

rndVar :: String
rndVar = "rnd"

calculateName :: Int -> String
calculateName rnd = "calculate_rnd" ++ show rnd

phiName :: Int -> String
phiName n = "phi_" ++ show n

updChoiceLdr :: String
updChoiceLdr = updChoiceName ++ "[0]"

updChoiceName :: String
updChoiceName = "upd_choice" 
  
newStName :: String
newStName = "new_st"

compactName :: String
compactName = "compact"
