  for(#{iVar 1} in #{tsVarName 0}){
    #{tsVarName 0}[#{iVar 1}] = NEG_BYTE;
    #{tsVarName 1}[#{iVar 1}] = NEG_BYTE;
  }
  /* Insert all the timestamps of 0 into ts_of_0, all timestamps of 1
   into ts_of_1, SORTED! */

  for(#{iVar 1} in st_ctr){
    if
      :: st_ctr[#{iVar 1}] > 0 ->
         if
           :: decode_inp(#{iVar 1}) == 0 ->
              for(#{iVar 2} : 0 .. st_ctr[#{iVar 1}] - 1){
                #{iVar 3} = decode_ts(#{iVar 1});
                #{iVar 4} = 0;
                do
                  :: #{tsVarName 0}[#{iVar 4}] == NEG_BYTE ->
                     #{tsVarName 0}[#{iVar 4}] = #{iVar 3};
                     break;
                  :: #{tsVarName 0}[#{iVar 4}] > #{iVar 3} ->
                     swap(#{iVar 3}, #{tsVarName 0}[#{iVar 4}]);
                     #{iVar 4}++;
                  :: else ->
                     #{iVar 4}++;
                od;
              }

           :: decode_inp(#{iVar 1}) == 1 ->
              for(#{iVar 2} : 0 .. st_ctr[#{iVar 1}] - 1){
                #{iVar 3} = decode_ts(#{iVar 1});
                #{iVar 4} = 0;
                do
                  :: #{tsVarName 1}[#{iVar 4}] == NEG_BYTE ->
                     #{tsVarName 1}[#{iVar 4}] = #{iVar 3};
                     break;
                  :: #{tsVarName 1}[#{iVar 4}] > #{iVar 3} ->
                     swap(#{iVar 3}, #{tsVarName 1}[#{iVar 4}]);
                     #{iVar 4}++;
                  :: else ->
                     #{iVar 4}++;
                od;
              }
         fi;
      :: else -> skip;
    fi;
  }

  /* Decide if a local update of 0 is possible */
  #{iVar 1} = 0; /* Size of the largest possible 0-witness set */
  #{iVar 2} = 0; /* Maximum timestamp seen for 0 */
  for(#{iVar 3} in #{tsVarName 0}){
    if
      :: #{tsVarName 0}[#{iVar 3}] != NEG_BYTE ->
         #{iVar 1}++;
         #{iVar 2} = #{tsVarName 0}[#{iVar 3}];
      :: else -> break;
    fi;
  }

  if
    :: #{iVar 1} > 0 -> 
       for(#{iVar 3} in #{tsVarName 1}){
         if
           :: #{tsVarName 1}[#{iVar 3}] != NEG_BYTE && #{tsVarName 1}[#{iVar 3}] <= #{iVar 2} ->
              #{iVar 1}++;
           :: else -> break;
         fi;
       }
       
    :: else ->
       skip;
  fi;

  if
    :: #{overMaxTh (iVar 1)} -> #{possUpds "0"} = 1;
    :: else -> skip;
  fi;

  #{mixedBot 1}

  /* Decide if a local update of 1 is possible; almost the same as above */
  #{iVar 1} = 0; /* Size of the largest possible 1-witness set */
  #{iVar 2} = 0;
  for(#{iVar 3} in #{tsVarName 1}){
    if
      :: #{tsVarName 1}[#{iVar 3}] != NEG_BYTE ->
         #{iVar 1}++;
         #{iVar 2} = #{tsVarName 1}[#{iVar 3}];
      :: else -> break;
    fi;
  }

  if
    :: #{iVar 1} > 0 ->
       for(#{iVar 3} in #{tsVarName 0}){
         if
           /* unlike for the 0 case, here we require strict inequality */
           :: #{tsVarName 0}[#{iVar 3}] != NEG_BYTE && #{tsVarName 0}[#{iVar 3}] < #{iVar 2} ->
              #{iVar 1}++;
           :: else -> break;
         fi;
       }
       
    :: else ->
       skip;
  fi;

  if
    :: #{overMaxTh (iVar 1)} -> #{possUpds "1"} = 1;
    :: else -> skip;
  fi;

  #{mixedBot 1}

  if
    :: !#{phiThStr} -> #{possUpds "BOT"} = 1;
    :: else -> skip;
  fi;

  for(#{iVar 1} in #{tsVarName 0}){
    #{tsVarName 0}[#{iVar 1}] = 0;
    #{tsVarName 1}[#{iVar 1}] = 0;
  }

  #{iVar 1} = 0;
  #{iVar 2} = 0;
  #{iVar 3} = 0;
  #{iVar 4} = 0;
